#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire2900seven4xi .py">
#<abstract4xi abstract = "fires to direction seven and to distance 2900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2900seven4xi ']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SEVEN - COORDINATE SIGNS OF SHOOT2SEVEN4XI: (X - ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2seven29004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2seven29004xi = {
                1:'-1002x-2288y1471z',
                2:'-1108x-934y2511z',
                3:'-1113x-1043y2582z',
                4:'-1114x-2219y1496z',
                5:'-1116x-2508y932z',
                6:'-1135x-860y2525z',
                7:'-1158x-785y2540z',
                8:'-1175x-710y2553z',
                9:'-1188x-636y2567z',
                10:'-118x-1482y2489z',
                11:'-1197x-562y2580z',
                12:'-1201x-488y2593z',
                13:'-120x-2592y1293z',
                14:'-1221x-2145y1521z',
                15:'-1242x-2438y959z',
                16:'-1324x-2065y1546z',
                17:'-1363x-2361y986z',
                18:'-1421x-1980y1570z',
                19:'-146x-2800y737z',
                20:'-1479x-2278y1013z',
                21:'-1482x-2492y6z',
                22:'-1513x-1891y1594z',
                23:'-1590x-2189y1041z',
                24:'-1599x-1797y1619z',
                25:'-1610x-2411y35z',
                26:'-1679x-1699y1643z',
                27:'-1696x-2095y1068z',
                28:'-1734x-2323y64z',
                29:'-1754x-1598y1666z',
                30:'-1796x-1995y1095z',
                31:'-1822x-1493y1690z',
                32:'-1853x-2228y93z',
                33:'-1884x-1386y1714z',
                34:'-1890x-1890y1121z',
                35:'-192x-1449y2504z',
                36:'-1939x-1276y1737z',
                37:'-1966x-2127y122z',
                38:'-1978x-1781y1148z',
                39:'-1989x-1163y1760z',
                40:'-2031x-1050y1783z',
                41:'-2060x-1668y1175z',
                42:'-2067x-934y1806z',
                43:'-2074x-2021y151z',
                44:'-2096x-818y1828z',
                45:'-2118x-702y1851z',
                46:'-2134x-585y1873z',
                47:'-2135x-1551y1201z',
                48:'-2144x-468y1895z',
                49:'-2175x-1908y180z',
                50:'-2203x-1430y1227z',
                51:'-2264x-1307y1254z',
                52:'-2271x-1791y209z',
                53:'-2318x-1181y1280z',
                54:'-2359x-1668y238z',
                55:'-2365x-1053y1306z',
                56:'-2404x-923y1331z',
                57:'-2437x-791y1357z',
                58:'-2441x-1541y267z',
                59:'-2462x-659y1383z',
                60:'-2479x-527y1408z',
                61:'-2489x-394y1433z',
                62:'-2492x-261y1459z',
                63:'-2516x-1409y296z',
                64:'-254x-2569y1319z',
                65:'-2584x-1274y325z',
                66:'-263x-1412y2518z',
                67:'-2644x-1136y353z',
                68:'-2696x-995y382z',
                69:'-26x-28y2899z',
                70:'-2741x-851y411z',
                71:'-2778x-705y440z',
                72:'-27x-413y2870z',
                73:'-292x-2781y765z',
                74:'-331x-1372y2533z',
                75:'-387x-2539y1345z',
                76:'-395x-1328y2547z',
                77:'-41x-1511y2474z',
                78:'-436x-2754y793z',
                79:'-43x-52y2899z',
                80:'-455x-1282y2560z',
                81:'-46x-383y2874z',
                82:'-512x-1232y2574z',
                83:'-516x-2502y1370z',
                84:'-565x-1181y2587z',
                85:'-578x-2720y821z',
                86:'-58x-77y2898z',
                87:'-613x-1127y2600z',
                88:'-61x-352y2877z',
                89:'-643x-2458y1396z',
                90:'-658x-1071y2613z',
                91:'-698x-1013y2625z',
                92:'-6x-443y2865z',
                93:'-70x-104y2897z',
                94:'-717x-2678y849z',
                95:'-734x-954y2637z',
                96:'-73x-320y2881z',
                97:'-766x-895y2649z',
                98:'-767x-2408y1421z',
                99:'-793x-834y2661z',
                100:'-79x-133y2895z',
                101:'-7x-7y2899z',
                102:'-811x-149y2780z',
                103:'-817x-773y2672z',
                104:'-81x-288y2884z',
                105:'-829x-198y2771z',
                106:'-836x-712y2683z',
                107:'-844x-249y2763z',
                108:'-850x-651y2694z',
                109:'-854x-2628y876z',
                110:'-856x-302y2754z',
                111:'-861x-590y2705z',
                112:'-864x-356y2744z',
                113:'-868x-530y2715z',
                114:'-869x-413y2735z',
                115:'-86x-162y2894z',
                116:'-870x-471y2725z',
                117:'-87x-256y2887z',
                118:'-886x-2351y1446z',
                119:'-89x-193y2892z',
                120:'-90x-224y2889z',
                121:'-987x-2572y904z',
                122:'0x-2811y709z'}         
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire2900seven4xi " usage = "target function for charge2seven4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire2900seven4xi (queue2seven, consumer_channel2seven, publisher_channel2seven):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE2900SEVEN4XI - STARTED TIME: ", time2start)
        #  
        
        print("\n (STEP 1A2/33) OF FIRE2900SEVEN4XI -  QUEUE2SEVEN: ", queue2seven)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE2900SEVEN4XI -  CONSUMER_CHANNEL2SEVEN: ", consumer_channel2seven)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE2900SEVEN4XI -  PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE2900SEVEN4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2seven.put(shot2seven29004xi) 
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE2900SEVEN4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE2900SEVEN4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE2900SEVEN4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2seven8shot2seven29004xi </ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2seven8shot2seven29004xi </nack2put4xi>" 
            
        publisher_channel2seven.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE2900SEVEN4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE2900SEVEN4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SEVEN: ", publisher_channel2seven, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE2900SEVEN4XI - RETURNING QUEUE OBJECT QUEUE2SEVEN: ", queue2seven, " - TIME: ", time4xi())  
        # 
            
    return queue2seven    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire2900seven4xi .py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

       